#!/usr/bin/perl
sub usage_error{
    die "Usage: translator.pl [-d path/to/docbookx.dtd] language file+
Supportd languages are en or fr.";
}

if ($#ARGV < 1) {&usage_error;};
$lang = shift;
if ($lang eq "-d") { #this is the DTD to use
    $dtd = shift;
    $lang = shift;
} else { #use default dtd
    $dtd = "/usr/share/sgml/docbook/dtd/xml/4.1.2/docbookx.dtd";
}
if ( !($lang =~/en|fr/) ) {
    &usage_error;
}
    
while ($filename = shift) {
	open(IN, $filename) or die "Can't open file: $filename";
	#Construction du nom de fichier de sortie.
	$filename =~ /(.*)\.(.*)/;
	$outfile = $1 . "-$lang." . $2;
	print "Output file : $outfile\n";
	open(OUT, ">$outfile") or die "Cant opent output file for writing" ;
	
	#lecture du fichier -- on met tout en memoire!
	$/ = undef;
	$f = <IN>;
	#Substitute the fictive DTD system value by the real one
	$f =~ s/(<!DOCTYPE (book|article) PUBLIC \"-\/\/OASIS\/\/DTD DocBookX? V4.1.2\/\/EN\" \")docbookx.dtd/$1$dtd/; #"
	#un gros coup de regexp pour separer ce qui nous interesse 
	$f =~ s/<:$lang (.*?):>/$1/sg;
	#et on jette le reste
	$f =~ s/<:.*?:>//sg;
	$f =~ s/\n+/\n/g;
	# on sauve dans le fichier de sortie
	print OUT $f;
	close OUT;
	#et on compile
	#system("sgml2html --language=$lang $outfile");
}
